package com.test.consumer.controller;

import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.ObjectInputStream;
import java.io.PrintWriter;
import java.util.List;

import javax.servlet.http.HttpServletResponse;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import com.scudata.dm.DataStruct;
import com.scudata.dm.Record;
import com.scudata.dm.Sequence;
import com.test.consumer.feign.SplFeignClient;

@Controller
@RequestMapping("/page")
public class ConsumeController {
	@Autowired
	SplFeignClient client;
	
	
	@RequestMapping(value="/result/hsql", produces = "text/html;charset=UTF-8")
	@ResponseBody
	public void getResult1(HttpServletResponse res) {
		res.setContentType("text/html;charset=UTF-8");
		byte[] result = client.queryFromHsql();
		InputStream in = new ByteArrayInputStream(result);
		try {
			ObjectInputStream ois = new ObjectInputStream(in);
			Object readObject = ois.readObject();
			List<String[]> seq = (List<String[]>) readObject;
			PrintWriter writer = res.getWriter();
			writer.write("<table>");
			writer.write("<tr>");
			for(int i = 0; i < seq.get(0).length; i++) {
				String fieldName = seq.get(0)[i];
				writer.write("<td>");
				writer.write(fieldName);
				writer.write("</td>");
			}
			writer.write("</tr>");
			for(int i = 1; i < seq.size(); i++) {
				writer.write("<tr>");
				String[] re = seq.get(i);
				for(int j = 0; j < re.length; j++) {
					String fv = re[j];
					writer.write("<td>");
					writer.write(fv == null ? "null" :fv.toString());
					writer.write("</td>");
				}
				writer.write("</tr>");
			}
			writer.write("</table>");
			writer.flush();
		} catch (IOException e) {
			e.printStackTrace();
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	@RequestMapping(value="/result/mysql", produces = "text/html;charset=UTF-8")
	@ResponseBody
	public void getResult2(HttpServletResponse res) {
		res.setContentType("text/html;charset=UTF-8");
		byte[] result = client.queryFromMysql();
		InputStream in = new ByteArrayInputStream(result);
		try {
			ObjectInputStream ois = new ObjectInputStream(in);
			Object readObject = ois.readObject();
			List<String[]> seq = (List<String[]>) readObject;
			PrintWriter writer = res.getWriter();
			writer.write("<table>");
			writer.write("<tr>");
			for(int i = 0; i < seq.get(0).length; i++) {
				String fieldName = seq.get(0)[i];
				writer.write("<td>");
				writer.write(fieldName);
				writer.write("</td>");
			}
			writer.write("</tr>");
			for(int i = 1; i < seq.size(); i++) {
				writer.write("<tr>");
				String[] re = seq.get(i);
				for(int j = 0; j < re.length; j++) {
					String fv = re[j];
					writer.write("<td>");
					writer.write(fv == null ? "null" :fv.toString());
					writer.write("</td>");
				}
				writer.write("</tr>");
			}
			writer.write("</table>");
			writer.flush();
		} catch (IOException e) {
			e.printStackTrace();
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
}
