package com.test.config;


import javax.sql.DataSource;

import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.jdbc.core.JdbcTemplate;

import com.alibaba.druid.spring.boot.autoconfigure.DruidDataSourceBuilder;

/**
 * springboot + spring-jdbc + ali-druid add datasources
 *
 */
@Configuration
public class MultiDsBeanConfig {
	@Bean("spring_ds_Mysql")
    @ConfigurationProperties("spring.datasource.ds1")
    public DataSource datasourceMysql() {
        return DruidDataSourceBuilder.create().build();
    }
	
	@Bean("spring_ds_hsql")
    @ConfigurationProperties("spring.datasource.ds2")
    public DataSource spring_hsql() {
        return DruidDataSourceBuilder.create().build();
    }
	
	@Bean("jdbcTemplateMysql")
    public JdbcTemplate jdbcTemplateMysql() {
        return new JdbcTemplate(datasourceMysql());
    }
	
	@Bean("jdbcTemplateHsql")
    public JdbcTemplate jdbcTemplateHsql() {
        return new JdbcTemplate(spring_hsql());
    }
}
