package com.test.controller;

import java.io.ByteArrayOutputStream;
import java.io.ObjectOutputStream;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.util.ArrayList;
import java.util.List;

import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import com.scudata.common.Logger;
import com.scudata.dm.Env;

@Controller
@RequestMapping("/spl")
public class SplExecuterController {
	@RequestMapping("/execute/hsqltest")
	@ResponseBody
	public byte[] execute() throws Exception { 
		//test session factory working
		//test run splx, using spl script =connect("spring datasource id"), 
		//like  =connect("spring_ds_hsql"), with the datasource id declared in DsBeanConfigMulti
		Logger.debug("running spring.splx");
		Env.setMainPath("E:/tmp1/");
		ResultSet re = jdbcExecuteSplx("spring.splx");
		Logger.debug("---result: printing Table");
		Logger.debug(re);
		if(re instanceof ResultSet) {
			ByteArrayOutputStream bos = new ByteArrayOutputStream();
		    ObjectOutputStream oos = new ObjectOutputStream(bos);
		    String field1 = "name";
		    String field2 = "gender";
		    String field3 = "hiredate";
		    List<String[]> result = new ArrayList<String[]>();
		    result.add(new String[] {field1, field2, field3});
		    while(re.next()) {
		    	String v1 = re.getString(1);
		    	String v2 = re.getString(2);
		    	String v3 = re.getString(3);
		    	result.add(new String[] {v1, v2, v3});
		    }
		    oos.writeObject(result);
		    byte[] bytes = bos.toByteArray();
			return bytes;
		}else {
			return null;
		}
	}
	
	@RequestMapping("/execute/mysqltest")
	@ResponseBody
	public byte[] execute2() throws Exception { 
		//test session factory working
		//test run splx, using spl script =connect("spring datasource id"), 
		//like  =connect("spring_ds_Mysql"), with the datasource id declared in DsBeanConfigMulti
		Logger.debug("running spring2.splx");
		Env.setMainPath("E:/tmp1/");
		ResultSet re = jdbcExecuteSplx("spring2.splx");
		Logger.debug("---result: printing Table");
		Logger.debug(re);
		if(re instanceof ResultSet) {
			ByteArrayOutputStream bos = new ByteArrayOutputStream();
		    ObjectOutputStream oos = new ObjectOutputStream(bos);
		    String field1 = "name";
		    String field2 = "age";
		    String field3 = "grade";
		    String field4 = "class";
		    List<String[]> result = new ArrayList<String[]>();
		    result.add(new String[] {field1, field2, field3, field4});
		    while(re.next()) {
		    	String v1 = re.getString(1);
		    	String v2 = re.getString(2);
		    	String v3 = re.getString(3);
		    	String v4 = re.getString(4);
		    	result.add(new String[] {v1, v2, v3, v4});
		    }
		    oos.writeObject(result);
		    byte[] bytes = bos.toByteArray();
			return bytes;
		}else {
			return null;
		}
	}
	
	public ResultSet jdbcExecuteSplx(String fileName){
		Connection con = null;
		java.sql.PreparedStatement st;
		try{
			Class.forName("com.esproc.jdbc.InternalDriver");
			con= DriverManager.getConnection("jdbc:esproc:local://");
			st =con.prepareCall("call "+fileName+"()");
			st.execute();
			ResultSet set = st.getResultSet();
			return set;
		} catch (Exception e){
			e.printStackTrace();
			return null;
		} finally {
			if (con!=null) {
				try {
					con.close();
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		}
	}
}
